options(java.parameters = "- Xmx1024m")

library(ROracle)
library(dplyr)
library(XLConnect)

# connect to Oracle database (registry_reporting)
drv <- dbDriver("Oracle")
host <- "oci-mmmrpprd-prod.local.medstreaming.net"
sid <- "MMMRPPRD"
pwd <- pass <- getPass::getPass("Enter database password:")
port <- 1521
connect.string <- paste("(DESCRIPTION=", "(ADDRESS=(PROTOCOL=tcp)(HOST=",
                        host, ")(PORT=", port, "))", "(CONNECT_DATA=(SID=",
                        sid, ")))", sep = "")
con <- dbConnect(drv, username = "registry_reporting",
                 password = pwd, dbname = connect.string)

setwd("") #Add in your folder

date <- Sys.Date()
date_formated <- paste0(substring(date,6,7),substring(date,9,10),substring(date,3,4))

sales_device_report <- fetch(dbSendQuery(con, "select count (distinct l.PRIMPROCID) Proc_Count, l.fieldname,
decode (l.FIELDNAME, 'AOFAS_H_VALGUS_MT_S_OST', 'AOFAS', 'AOFAS_H_VALGUS_PH_OST', 'AOFAS', 'AOFAS_H_VALGUS_P_MT_OST', 'AOFAS',
        'AOFAS_AA_TAR_IMPLANT', 'AOFAS', 'AOFAS_H_VALGUS_D_MT_OST', 'AOFAS', 'STENT_RTRVR_AIS', 'SNIS', 'INT_CATH_USED_AIS', 'SNIS',
        'STROKE_STENT_TYPES', 'SNIS', 'APS_CATHETER_AIS', 'SNIS', 'COIL_MICRO_CATH', 'SNIS', 'FLOW_DIVERTER', 'SNIS', 'FRAMING_COILS', 'SNIS',
        'BALLOON_ASSIST', 'SNIS', 'PRIM_GUIDE_SHEATH', 'SNIS', 'STD_GUIDE_CATH', 'SNIS', 'STENT_ASSIST', 'SNIS', 'CLIP_TYPE', 'SNIS',
        'FLOW_DISRUPTOR', 'SNIS', 'NONCOIL_MICRO_CATH', 'SNIS', 'INTERMED_CATH', 'SNIS', 'FRAMING_COILS', 'SNIS', 'TYPE_RADIOSURG', 'SNIS', 'SVS') Society,
decode (l.PROCEDUREID, '25', 'OFAR', '17', 'AIS', '21', 'CBA', '22', 'AVM', '1', 'CEA', '12', 'AVACCESS', '16', 'IVC',
        '18', 'TEVAR', '19', 'EVAR', '20', 'VV', '23', 'PVI', '24', 'CAS', '2', 'INFRA', '27', 'VSR', l.Procedureid) Procedure,
l.GRAFT_TYPE Manufacturer, l.DEVICE_NAME, g.gmdnptname as GUDID_Category,
case when m.ltfstatusflag = 'C' then 'Follow-Up' else 'No_FU' end Follow_Up
from REGISTRY_REPORTING.REG_DEVICE_LIST l
left join REGISTRY_REPORTING.reg_graft_lookup g on l.graft_config = g.graft_config
left join registry_reporting.mst_ltf_mv m on l.primprocid = m.primprocid
group by
l.fieldname,
decode (l.FIELDNAME, 'AOFAS_H_VALGUS_MT_S_OST', 'AOFAS', 'AOFAS_H_VALGUS_PH_OST', 'AOFAS', 'AOFAS_H_VALGUS_P_MT_OST', 'AOFAS',
        'AOFAS_AA_TAR_IMPLANT', 'AOFAS', 'AOFAS_H_VALGUS_D_MT_OST', 'AOFAS', 'STENT_RTRVR_AIS', 'SNIS', 'INT_CATH_USED_AIS', 'SNIS',
        'STROKE_STENT_TYPES', 'SNIS', 'APS_CATHETER_AIS', 'SNIS', 'COIL_MICRO_CATH', 'SNIS', 'FLOW_DIVERTER', 'SNIS', 'FRAMING_COILS', 'SNIS',
        'BALLOON_ASSIST', 'SNIS', 'PRIM_GUIDE_SHEATH', 'SNIS', 'STD_GUIDE_CATH', 'SNIS', 'STENT_ASSIST', 'SNIS', 'CLIP_TYPE', 'SNIS',
        'FLOW_DISRUPTOR', 'SNIS', 'NONCOIL_MICRO_CATH', 'SNIS', 'INTERMED_CATH', 'SNIS', 'FRAMING_COILS', 'SNIS', 'TYPE_RADIOSURG', 'SNIS', 'SVS'),
decode (l.PROCEDUREID, '25', 'OFAR', '17', 'AIS', '21', 'CBA', '22', 'AVM', '1', 'CEA', '12', 'AVACCESS', '16', 'IVC',
        '18', 'TEVAR', '19', 'EVAR', '20', 'VV', '23', 'PVI', '24', 'CAS', '2', 'INFRA', '27', 'VSR', l.Procedureid),
l.GRAFT_TYPE, l.DEVICE_NAME, g.gmdnptname, case when m.ltfstatusflag = 'C' then 'Follow-Up' else 'No_FU' end
order by 2"))

sales_device_report[is.na(sales_device_report)] <- ""

names(sales_device_report)[8] <- "Follow-up?"

wb <- loadWorkbook("_Device Report TEMPLATE blank.xlsx", create=TRUE)
setStyleAction(wb,XLC$"STYLE_ACTION.NONE")
writeWorksheet(wb,sales_device_report,"raw data",startRow=1,startCol=1,header=TRUE)
xlsx_name <- paste0("_Device Report ",date_formated,".xlsx")
saveWorkbook(wb,xlsx_name)

# write.csv(file = "sales_device_report.csv",sales_device_report,row.names = FALSE)

####
all_other_device_report <- fetch(dbSendQuery(con, "

--IVCF
select * from (select distinct 'CEA_PROC' as Registry, primprocid, DEVICE_MFR_OTHER
               from registry_reporting.dfl_gen_ivc_pso_v
               where nvl(DEVICE_MFR_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (DEVICE_MFR_OTHER as 'DEVICE_MFR_OTHER'))
union
select * from (select distinct 'CEA_PROC' as Registry, primprocid, IVC_FILTER_TYPE_OTHER
               from registry_reporting.dfl_gen_ivc_pso_v
               where nvl(IVC_FILTER_TYPE_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (IVC_FILTER_TYPE_OTHER as 'IVC_FILTER_TYPE_OTHER'))
union
--CEA
select * from (select distinct 'CEA_PROC' as Registry, primprocid, PATCH_MANUFACTURER_OTHER
               from registry_reporting.dfl_gen_cea_pso_v
               where nvl(PATCH_MANUFACTURER_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (PATCH_MANUFACTURER_OTHER as 'PATCH_MANUFACTURER_OTHER'))
union
--CAS
select * from (select distinct 'CAS_PROC' as Registry, primprocid, OTHER_DEV_INFO_L1
               from registry_reporting.dfl_gen_cas_new_pso_v
               where nvl(OTHER_DEV_INFO_L1,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_DEV_INFO_L1 as 'OTHER_DEV_INFO_L1'))
union
select * from (select distinct 'CAS_PROC' as Registry, primprocid, OTHER_DEV_INFO_L2
               from registry_reporting.dfl_gen_cas_new_pso_v
               where nvl(OTHER_DEV_INFO_L2,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_DEV_INFO_L2 as 'OTHER_DEV_INFO_L2'))
union
select * from (select distinct 'CAS_PROC' as Registry, primprocid, DISTAL_EPD_TYPE_OTHER_1
               from registry_reporting.dfl_gen_cas_new_pso_v
               where nvl(DISTAL_EPD_TYPE_OTHER_1,'N/A') != 'N/A')
unpivot (data for fields in (DISTAL_EPD_TYPE_OTHER_1 as 'DISTAL_EPD_TYPE_OTHER_1'))
union
select * from (select distinct 'CAS_PROC' as Registry, primprocid, DISTAL_EPD_TYPE_OTHER_2
               from registry_reporting.dfl_gen_cas_new_pso_v
               where nvl(DISTAL_EPD_TYPE_OTHER_2,'N/A') != 'N/A')
unpivot (data for fields in (DISTAL_EPD_TYPE_OTHER_2 as 'DISTAL_EPD_TYPE_OTHER_2'))
union
select * from (select distinct 'CAS_PROC' as Registry, primprocid, FLOW_REV_TYPE_OTHER_1
               from registry_reporting.dfl_gen_cas_new_pso_v
               where nvl(FLOW_REV_TYPE_OTHER_1,'N/A') != 'N/A')
unpivot (data for fields in (FLOW_REV_TYPE_OTHER_1 as 'FLOW_REV_TYPE_OTHER_1'))
union
select * from (select distinct 'CAS_PROC' as Registry, primprocid, FLOW_REV_TYPE_OTHER_2
               from registry_reporting.dfl_gen_cas_new_pso_v
               where nvl(FLOW_REV_TYPE_OTHER_2,'N/A') != 'N/A')
unpivot (data for fields in (FLOW_REV_TYPE_OTHER_2 as 'FLOW_REV_TYPE_OTHER_2'))
union
--EVAR
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, CLOSURE_DEV_OTHER_R
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(CLOSURE_DEV_OTHER_R,'N/A') != 'N/A')
unpivot (data for fields in (CLOSURE_DEV_OTHER_R as 'CLOSURE_DEV_OTHER_R'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, CLOSURE_DEV_OTHER_L
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(CLOSURE_DEV_OTHER_L,'N/A') != 'N/A')
unpivot (data for fields in (CLOSURE_DEV_OTHER_L as 'CLOSURE_DEV_OTHER_L'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, ANCHORS_USED_OTHER
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(ANCHORS_USED_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (ANCHORS_USED_OTHER as 'ANCHORS_USED_OTHER'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, RETX_ANCHORS_USED_OTHER
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(RETX_ANCHORS_USED_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (RETX_ANCHORS_USED_OTHER as 'RETX_ANCHORS_USED_OTHER'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, RETX_GRAFT_MFG_OTHER_1
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(RETX_GRAFT_MFG_OTHER_1,'N/A') != 'N/A')
unpivot (data for fields in (RETX_GRAFT_MFG_OTHER_1 as 'RETX_GRAFT_MFG_OTHER_1'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, RETX_GRAFT_MFG_OTHER_2
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(RETX_GRAFT_MFG_OTHER_2,'N/A') != 'N/A')
unpivot (data for fields in (RETX_GRAFT_MFG_OTHER_2 as 'RETX_GRAFT_MFG_OTHER_2'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, RETX_GRAFT_MFG_OTHER_3
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(RETX_GRAFT_MFG_OTHER_3,'N/A') != 'N/A')
unpivot (data for fields in (RETX_GRAFT_MFG_OTHER_3 as 'RETX_GRAFT_MFG_OTHER_3'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, RETX_GRAFT_MFG_OTHER_4
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(RETX_GRAFT_MFG_OTHER_4,'N/A') != 'N/A')
unpivot (data for fields in (RETX_GRAFT_MFG_OTHER_4 as 'RETX_GRAFT_MFG_OTHER_4'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, SPEC_MANU_GRAFT_DETAILS_1
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(SPEC_MANU_GRAFT_DETAILS_1,'N/A') != 'N/A')
unpivot (data for fields in (SPEC_MANU_GRAFT_DETAILS_1 as 'SPEC_MANU_GRAFT_DETAILS_1'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, SPEC_MANU_GRAFT_DETAILS_2
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(SPEC_MANU_GRAFT_DETAILS_2,'N/A') != 'N/A')
unpivot (data for fields in (SPEC_MANU_GRAFT_DETAILS_2 as 'SPEC_MANU_GRAFT_DETAILS_2'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, SPEC_MANU_GRAFT_DETAILS_3
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(SPEC_MANU_GRAFT_DETAILS_3,'N/A') != 'N/A')
unpivot (data for fields in (SPEC_MANU_GRAFT_DETAILS_3 as 'SPEC_MANU_GRAFT_DETAILS_3'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, SPEC_MANU_GRAFT_DETAILS_4
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(SPEC_MANU_GRAFT_DETAILS_4,'N/A') != 'N/A')
unpivot (data for fields in (SPEC_MANU_GRAFT_DETAILS_4 as 'SPEC_MANU_GRAFT_DETAILS_4'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, SPEC_MFG_GRAFT_DET_RT_1
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(SPEC_MFG_GRAFT_DET_RT_1,'N/A') != 'N/A')
unpivot (data for fields in (SPEC_MFG_GRAFT_DET_RT_1 as 'SPEC_MFG_GRAFT_DET_RT_1'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, SPEC_MFG_GRAFT_DET_RT_2
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(SPEC_MFG_GRAFT_DET_RT_2,'N/A') != 'N/A')
unpivot (data for fields in (SPEC_MFG_GRAFT_DET_RT_2 as 'SPEC_MFG_GRAFT_DET_RT_2'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, SPEC_MFG_GRAFT_DET_RT_3
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(SPEC_MFG_GRAFT_DET_RT_3,'N/A') != 'N/A')
unpivot (data for fields in (SPEC_MFG_GRAFT_DET_RT_3 as 'SPEC_MFG_GRAFT_DET_RT_3'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, SPECIFY_MFG_GRAFT_DET_LT_1
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(SPECIFY_MFG_GRAFT_DET_LT_1,'N/A') != 'N/A')
unpivot (data for fields in (SPECIFY_MFG_GRAFT_DET_LT_1 as 'SPECIFY_MFG_GRAFT_DET_LT_1'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, SPECIFY_MFG_GRAFT_DET_LT_2
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(SPECIFY_MFG_GRAFT_DET_LT_2,'N/A') != 'N/A')
unpivot (data for fields in (SPECIFY_MFG_GRAFT_DET_LT_2 as 'SPECIFY_MFG_GRAFT_DET_LT_2'))
union
select * from (select distinct 'EVAR_PROC' as Registry, primprocid, SPECIFY_MFG_GRAFT_DET_LT_3
               from registry_reporting.dfl_gen_evar_pso_v
               where nvl(SPECIFY_MFG_GRAFT_DET_LT_3,'N/A') != 'N/A')
unpivot (data for fields in (SPECIFY_MFG_GRAFT_DET_LT_3 as 'SPECIFY_MFG_GRAFT_DET_LT_3'))
union
--EVAR LTF
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX1_GRAFT_MFG_OTHER_1
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX1_GRAFT_MFG_OTHER_1,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX1_GRAFT_MFG_OTHER_1 as 'LTF_RETX1_GRAFT_MFG_OTHER_1'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX1_GRAFT_MFG_OTHER_2
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX1_GRAFT_MFG_OTHER_2,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX1_GRAFT_MFG_OTHER_2 as 'LTF_RETX1_GRAFT_MFG_OTHER_2'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX1_GRAFT_MFG_OTHER_3
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX1_GRAFT_MFG_OTHER_3,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX1_GRAFT_MFG_OTHER_3 as 'LTF_RETX1_GRAFT_MFG_OTHER_3'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX1_GRAFT_MFG_OTHER_4
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX1_GRAFT_MFG_OTHER_4,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX1_GRAFT_MFG_OTHER_4 as 'LTF_RETX1_GRAFT_MFG_OTHER_4'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX2_GRAFT_MFG_OTHER_1
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX2_GRAFT_MFG_OTHER_1,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX2_GRAFT_MFG_OTHER_1 as 'LTF_RETX2_GRAFT_MFG_OTHER_1'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX2_GRAFT_MFG_OTHER_2
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX2_GRAFT_MFG_OTHER_2,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX2_GRAFT_MFG_OTHER_2 as 'LTF_RETX2_GRAFT_MFG_OTHER_2'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX2_GRAFT_MFG_OTHER_3
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX2_GRAFT_MFG_OTHER_3,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX2_GRAFT_MFG_OTHER_3 as 'LTF_RETX2_GRAFT_MFG_OTHER_3'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX2_GRAFT_MFG_OTHER_4
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX2_GRAFT_MFG_OTHER_4,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX2_GRAFT_MFG_OTHER_4 as 'LTF_RETX2_GRAFT_MFG_OTHER_4'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX3_GRAFT_MFG_OTHER_1
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX3_GRAFT_MFG_OTHER_1,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX3_GRAFT_MFG_OTHER_1 as 'LTF_RETX3_GRAFT_MFG_OTHER_1'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX3_GRAFT_MFG_OTHER_2
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX3_GRAFT_MFG_OTHER_2,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX3_GRAFT_MFG_OTHER_2 as 'LTF_RETX3_GRAFT_MFG_OTHER_2'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX3_GRAFT_MFG_OTHER_3
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX3_GRAFT_MFG_OTHER_3,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX3_GRAFT_MFG_OTHER_3 as 'LTF_RETX3_GRAFT_MFG_OTHER_3'))
union
select * from (select distinct 'EVAR_LTF' as Registry, primprocid, LTF_RETX3_GRAFT_MFG_OTHER_4
               from registry_reporting.dfl_gen_EVAR_FBDS_pso_v
               where nvl(LTF_RETX3_GRAFT_MFG_OTHER_4,'N/A') != 'N/A')
unpivot (data for fields in (LTF_RETX3_GRAFT_MFG_OTHER_4 as 'LTF_RETX3_GRAFT_MFG_OTHER_4'))
union
--TEVAR
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D1_B1
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(BRANCH_DEVICE_OTH_D1_B1,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D1_B1 as 'BRANCH_DEVICE_OTH_D1_B1'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D1_B2
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(BRANCH_DEVICE_OTH_D1_B2,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D1_B2 as 'BRANCH_DEVICE_OTH_D1_B2'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D1_B3
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(BRANCH_DEVICE_OTH_D1_B3,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D1_B3 as 'BRANCH_DEVICE_OTH_D1_B3'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D1_B4
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D1_B4,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D1_B4 as 'BRANCH_DEVICE_OTH_D1_B4'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D1_B5
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D1_B5,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D1_B5 as 'BRANCH_DEVICE_OTH_D1_B5'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D1_B6
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D1_B6,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D1_B6 as 'BRANCH_DEVICE_OTH_D1_B6'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D1_B7
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D1_B7,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D1_B7 as 'BRANCH_DEVICE_OTH_D1_B7'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D1_B8
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D1_B8,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D1_B8 as 'BRANCH_DEVICE_OTH_D1_B8'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D1_B9
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D1_B9,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D1_B9 as 'BRANCH_DEVICE_OTH_D1_B9'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D2_B1
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D2_B1,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D2_B1 as 'BRANCH_DEVICE_OTH_D2_B1'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D2_B2
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D2_B2,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D2_B2 as 'BRANCH_DEVICE_OTH_D2_B2'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D2_B3
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D2_B3,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D2_B3 as 'BRANCH_DEVICE_OTH_D2_B3'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D2_B4
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D2_B4,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D2_B4 as 'BRANCH_DEVICE_OTH_D2_B4'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D2_B5
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D2_B5,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D2_B5 as 'BRANCH_DEVICE_OTH_D2_B5'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D2_B6
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D2_B6,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D2_B6 as 'BRANCH_DEVICE_OTH_D2_B6'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D2_B7
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D2_B7,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D2_B7 as 'BRANCH_DEVICE_OTH_D2_B7'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D2_B8
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D2_B8,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D2_B8 as 'BRANCH_DEVICE_OTH_D2_B8'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, BRANCH_DEVICE_OTH_D2_B9
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(BRANCH_DEVICE_OTH_D2_B9,'N/A') != 'N/A')
unpivot (data for fields in (BRANCH_DEVICE_OTH_D2_B9 as 'BRANCH_DEVICE_OTH_D2_B9'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, GRAFT_MFG_OTHER_D1
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(GRAFT_MFG_OTHER_D1,'N/A') != 'N/A')
unpivot (data for fields in (GRAFT_MFG_OTHER_D1 as 'GRAFT_MFG_OTHER_D1'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, GRAFT_MFG_OTHER_D2
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(GRAFT_MFG_OTHER_D2,'N/A') != 'N/A')
unpivot (data for fields in (GRAFT_MFG_OTHER_D2 as 'GRAFT_MFG_OTHER_D2'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, GRAFT_MFG_OTHER_D3
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(GRAFT_MFG_OTHER_D3,'N/A') != 'N/A')
unpivot (data for fields in (GRAFT_MFG_OTHER_D3 as 'GRAFT_MFG_OTHER_D3'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, GRAFT_MFG_OTHER_D4
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(GRAFT_MFG_OTHER_D4,'N/A') != 'N/A')
unpivot (data for fields in (GRAFT_MFG_OTHER_D4 as 'GRAFT_MFG_OTHER_D4'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, GRAFT_MFG_OTHER_D5
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(GRAFT_MFG_OTHER_D5,'N/A') != 'N/A')
unpivot (data for fields in (GRAFT_MFG_OTHER_D5 as 'GRAFT_MFG_OTHER_D5'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, GRAFT_MFG_OTHER_D6
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(GRAFT_MFG_OTHER_D6,'N/A') != 'N/A')
unpivot (data for fields in (GRAFT_MFG_OTHER_D6 as 'GRAFT_MFG_OTHER_D6'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, ILIAC_DEVICE_MFG_OTHER_D1
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(ILIAC_DEVICE_MFG_OTHER_D1,'N/A') != 'N/A')
unpivot (data for fields in (ILIAC_DEVICE_MFG_OTHER_D1 as 'ILIAC_DEVICE_MFG_OTHER_D1'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, ILIAC_DEVICE_MFG_OTHER_D2
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(ILIAC_DEVICE_MFG_OTHER_D2,'N/A') != 'N/A')
unpivot (data for fields in (ILIAC_DEVICE_MFG_OTHER_D2 as 'ILIAC_DEVICE_MFG_OTHER_D2'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, ILIAC_DEVICE_MFG_OTHER_D3
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(ILIAC_DEVICE_MFG_OTHER_D3,'N/A') != 'N/A')
unpivot (data for fields in (ILIAC_DEVICE_MFG_OTHER_D3 as 'ILIAC_DEVICE_MFG_OTHER_D3'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, ILIAC_DEVICE_MFG_OTHER_D4
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(ILIAC_DEVICE_MFG_OTHER_D4,'N/A') != 'N/A')
unpivot (data for fields in (ILIAC_DEVICE_MFG_OTHER_D4 as 'ILIAC_DEVICE_MFG_OTHER_D4'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_GRAFT_MFG_OTHER_D1
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(RETX1_GRAFT_MFG_OTHER_D1,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_GRAFT_MFG_OTHER_D1 as 'RETX1_GRAFT_MFG_OTHER_D1'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_GRAFT_MFG_OTHER_D2
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(RETX1_GRAFT_MFG_OTHER_D2,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_GRAFT_MFG_OTHER_D2 as 'RETX1_GRAFT_MFG_OTHER_D2'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_GRAFT_MFG_OTHER_D3
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(RETX1_GRAFT_MFG_OTHER_D3,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_GRAFT_MFG_OTHER_D3 as 'RETX1_GRAFT_MFG_OTHER_D3'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_BRCH_DEV_OTH_D1_B1
               from registry_reporting.dfl_gen_tevar_pso_Ov
               where nvl(RETX1_BRCH_DEV_OTH_D1_B1,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_BRCH_DEV_OTH_D1_B1 as 'RETX1_BRCH_DEV_OTH_D1_B1'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_BRCH_DEV_OTH_D1_B2
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX1_BRCH_DEV_OTH_D1_B2,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_BRCH_DEV_OTH_D1_B2 as 'RETX1_BRCH_DEV_OTH_D1_B2'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_BRCH_DEV_OTH_D1_B3
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX1_BRCH_DEV_OTH_D1_B3,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_BRCH_DEV_OTH_D1_B3 as 'RETX1_BRCH_DEV_OTH_D1_B3'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_BRCH_DEV_OTH_D1_B4
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX1_BRCH_DEV_OTH_D1_B4,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_BRCH_DEV_OTH_D1_B4 as 'RETX1_BRCH_DEV_OTH_D1_B4'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_BRCH_DEV_OTH_D1_B5
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX1_BRCH_DEV_OTH_D1_B5,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_BRCH_DEV_OTH_D1_B5 as 'RETX1_BRCH_DEV_OTH_D1_B5'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_BRCH_DEV_OTH_D2_B1
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX1_BRCH_DEV_OTH_D2_B1,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_BRCH_DEV_OTH_D2_B1 as 'RETX1_BRCH_DEV_OTH_D2_B1'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_BRCH_DEV_OTH_D2_B2
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX1_BRCH_DEV_OTH_D2_B2,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_BRCH_DEV_OTH_D2_B2 as 'RETX1_BRCH_DEV_OTH_D2_B2'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_BRCH_DEV_OTH_D2_B3
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX1_BRCH_DEV_OTH_D2_B3,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_BRCH_DEV_OTH_D2_B3 as 'RETX1_BRCH_DEV_OTH_D2_B3'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_BRCH_DEV_OTH_D2_B4
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX1_BRCH_DEV_OTH_D2_B4,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_BRCH_DEV_OTH_D2_B4 as 'RETX1_BRCH_DEV_OTH_D2_B4'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_BRCH_DEV_OTH_D2_B5
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX1_BRCH_DEV_OTH_D2_B5,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_BRCH_DEV_OTH_D2_B5 as 'RETX1_BRCH_DEV_OTH_D2_B5'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_GRAFT_MFG_OTHER_D1
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(RETX2_GRAFT_MFG_OTHER_D1,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_GRAFT_MFG_OTHER_D1 as 'RETX2_GRAFT_MFG_OTHER_D1'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_GRAFT_MFG_OTHER_D2
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(RETX2_GRAFT_MFG_OTHER_D2,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_GRAFT_MFG_OTHER_D2 as 'RETX2_GRAFT_MFG_OTHER_D2'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_GRAFT_MFG_OTHER_D3
               from registry_reporting.dfl_gen_tevar_pso_v
               where nvl(RETX2_GRAFT_MFG_OTHER_D3,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_GRAFT_MFG_OTHER_D3 as 'RETX2_GRAFT_MFG_OTHER_D3'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_BRCH_DEV_OTH_D1_B1
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_BRCH_DEV_OTH_D1_B1,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_BRCH_DEV_OTH_D1_B1 as 'RETX2_BRCH_DEV_OTH_D1_B1'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_BRCH_DEV_OTH_D1_B2
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_BRCH_DEV_OTH_D1_B2,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_BRCH_DEV_OTH_D1_B2 as 'RETX2_BRCH_DEV_OTH_D1_B2'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_BRCH_DEV_OTH_D1_B3
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_BRCH_DEV_OTH_D1_B3,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_BRCH_DEV_OTH_D1_B3 as 'RETX2_BRCH_DEV_OTH_D1_B3'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_BRCH_DEV_OTH_D1_B4
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_BRCH_DEV_OTH_D1_B4,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_BRCH_DEV_OTH_D1_B4 as 'RETX2_BRCH_DEV_OTH_D1_B4'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_BRCH_DEV_OTH_D1_B5
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_BRCH_DEV_OTH_D1_B5,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_BRCH_DEV_OTH_D1_B5 as 'RETX2_BRCH_DEV_OTH_D1_B5'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_BRCH_DEV_OTH_D2_B1
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_BRCH_DEV_OTH_D2_B1,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_BRCH_DEV_OTH_D2_B1 as 'RETX2_BRCH_DEV_OTH_D2_B1'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_BRCH_DEV_OTH_D2_B2
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_BRCH_DEV_OTH_D2_B2,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_BRCH_DEV_OTH_D2_B2 as 'RETX2_BRCH_DEV_OTH_D2_B2'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_BRCH_DEV_OTH_D2_B3
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_BRCH_DEV_OTH_D2_B3,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_BRCH_DEV_OTH_D2_B3 as 'RETX2_BRCH_DEV_OTH_D2_B3'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_BRCH_DEV_OTH_D2_B4
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_BRCH_DEV_OTH_D2_B4,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_BRCH_DEV_OTH_D2_B4 as 'RETX2_BRCH_DEV_OTH_D2_B4'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_BRCH_DEV_OTH_D2_B5
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_BRCH_DEV_OTH_D2_B5,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_BRCH_DEV_OTH_D2_B5 as 'RETX2_BRCH_DEV_OTH_D2_B5'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, CLOSURE_DEV_OTHER_R
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(CLOSURE_DEV_OTHER_R,'N/A') != 'N/A')
unpivot (data for fields in (CLOSURE_DEV_OTHER_R as 'CLOSURE_DEV_OTHER_R'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, CLOSURE_DEV_OTHER_L
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(CLOSURE_DEV_OTHER_L,'N/A') != 'N/A')
unpivot (data for fields in (CLOSURE_DEV_OTHER_L as 'CLOSURE_DEV_OTHER_L'))
union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, STAPLE_TYPE_OTHER
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(STAPLE_TYPE_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (STAPLE_TYPE_OTHER as 'STAPLE_TYPE_OTHER'))

union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX1_STAPLE_TYPE_OTHER
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX1_STAPLE_TYPE_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (RETX1_STAPLE_TYPE_OTHER as 'RETX1_STAPLE_TYPE_OTHER'))

union
select * from (select distinct 'TEVAR_PROC' as Registry, primprocid, RETX2_STAPLE_TYPE_OTHER
               from registry_reporting.dfl_gen_tevar_pso_ov
               where nvl(RETX2_STAPLE_TYPE_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (RETX2_STAPLE_TYPE_OTHER as 'RETX2_STAPLE_TYPE_OTHER'))
UNION

--TEVAR LTF
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D1_CELIAC
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D1_CELIAC,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D1_CELIAC as 'LTF_DEV_OTH_D1_CELIAC'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D1_INNO
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D1_INNO,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D1_INNO as 'LTF_DEV_OTH_D1_INNO'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D1_LCCA
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D1_LCCA,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D1_LCCA as 'LTF_DEV_OTH_D1_LCCA'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D1_LCOM
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D1_LCOM,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D1_LCOM as 'LTF_DEV_OTH_D1_LCOM'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D1_LRENAL
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D1_LRENAL,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D1_LRENAL as 'LTF_DEV_OTH_D1_LRENAL'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D1_LSUBC
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D1_LSUBC,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D1_LSUBC as 'LTF_DEV_OTH_D1_LSUBC'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D1_RCOM
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D1_RCOM,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D1_RCOM as 'LTF_DEV_OTH_D1_RCOM'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D1_RRENAL
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D1_RRENAL,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D1_RRENAL as 'LTF_DEV_OTH_D1_RRENAL'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D1_SMA
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D1_SMA,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D1_SMA as 'LTF_DEV_OTH_D1_SMA'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D2_CELIAC
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D2_CELIAC,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D2_CELIAC as 'LTF_DEV_OTH_D2_CELIAC'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D2_INNO
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D2_INNO,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D2_INNO as 'LTF_DEV_OTH_D2_INNO'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D2_LCCA
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D2_LCCA,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D2_LCCA as 'LTF_DEV_OTH_D2_LCCA'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D2_LCOM
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D2_LCOM,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D2_LCOM as 'LTF_DEV_OTH_D2_LCOM'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D2_LRENAL
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D2_LRENAL,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D2_LRENAL as 'LTF_DEV_OTH_D2_LRENAL'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D2_LSUBC
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D2_LSUBC,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D2_LSUBC as 'LTF_DEV_OTH_D2_LSUBC'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D2_RCOM
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D2_RCOM,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D2_RCOM as 'LTF_DEV_OTH_D2_RCOM'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D2_RRENAL
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D2_RRENAL,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D2_RRENAL as 'LTF_DEV_OTH_D2_RRENAL'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_DEV_OTH_D2_SMA
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_DEV_OTH_D2_SMA,'N/A') != 'N/A')
unpivot (data for fields in (LTF_DEV_OTH_D2_SMA as 'LTF_DEV_OTH_D2_SMA'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_GRAFT_MFG_OTHER_D1
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_GRAFT_MFG_OTHER_D1,'N/A') != 'N/A')
unpivot (data for fields in (LTF_GRAFT_MFG_OTHER_D1 as 'LTF_GRAFT_MFG_OTHER_D1'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_GRAFT_MFG_OTHER_D2
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_GRAFT_MFG_OTHER_D2,'N/A') != 'N/A')
unpivot (data for fields in (LTF_GRAFT_MFG_OTHER_D2 as 'LTF_GRAFT_MFG_OTHER_D2'))
union
select * from (select distinct 'TEVAR_LTF' as Registry, primprocid, LTF_GRAFT_MFG_OTHER_D3
               from registry_reporting.dfl_gen_tevar_fbds_pso_v
               where nvl(LTF_GRAFT_MFG_OTHER_D3,'N/A') != 'N/A')
unpivot (data for fields in (LTF_GRAFT_MFG_OTHER_D3 as 'LTF_GRAFT_MFG_OTHER_D3'))
union
--removed any fields in the 5yr project

--PVI
select * from (select distinct 'PVI_PROC' as Registry, primprocid, CLOSURE_TYPE_1_OTHER
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(CLOSURE_TYPE_1_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (CLOSURE_TYPE_1_OTHER as 'CLOSURE_TYPE_1_OTHER'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, CLOSURE_TYPE_2_OTHER
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(CLOSURE_TYPE_2_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (CLOSURE_TYPE_2_OTHER as 'CLOSURE_TYPE_2_OTHER'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_1
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_1,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_1 as 'OTHER_BLN_1'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_10
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_10,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_10 as 'OTHER_BLN_10'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_11
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_11,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_11 as 'OTHER_BLN_11'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_12
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_12,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_12 as 'OTHER_BLN_12'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_2
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_2,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_2 as 'OTHER_BLN_2'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_3
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_3,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_3 as 'OTHER_BLN_3'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_4
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_4,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_4 as 'OTHER_BLN_4'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_5
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_5,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_5 as 'OTHER_BLN_5'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_6
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_6,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_6 as 'OTHER_BLN_6'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_7
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_7,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_7 as 'OTHER_BLN_7'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_8
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_8,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_8 as 'OTHER_BLN_8'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_BLN_9
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_BLN_9,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_BLN_9 as 'OTHER_BLN_9'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_1
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_1,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_1 as 'OTHER_STENT_1'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_10
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_10,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_10 as 'OTHER_STENT_10'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_11
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_11,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_11 as 'OTHER_STENT_11'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_12
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_12,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_12 as 'OTHER_STENT_12'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_2
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_2,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_2 as 'OTHER_STENT_2'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_3
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_3,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_3 as 'OTHER_STENT_3'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_4
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_4,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_4 as 'OTHER_STENT_4'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_5
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_5,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_5 as 'OTHER_STENT_5'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_6
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_6,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_6 as 'OTHER_STENT_6'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_7
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_7,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_7 as 'OTHER_STENT_7'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_8
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_8,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_8 as 'OTHER_STENT_8'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, OTHER_STENT_9
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(OTHER_STENT_9,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_STENT_9 as 'OTHER_STENT_9'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, PVI_ANEUR_OTHER_DEVICE
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(PVI_ANEUR_OTHER_DEVICE,'N/A') != 'N/A')
unpivot (data for fields in (PVI_ANEUR_OTHER_DEVICE as 'PVI_ANEUR_OTHER_DEVICE'))
union
select * from (select distinct 'PVI_PROC' as Registry, primprocid, PVI_OCC_OTHER_DEVICE
               from registry_reporting.dfl_gen_pvi_new_pso_v
               where nvl(PVI_OCC_OTHER_DEVICE,'N/A') != 'N/A')
unpivot (data for fields in (PVI_OCC_OTHER_DEVICE as 'PVI_OCC_OTHER_DEVICE'))
union

--HEMO
select * from (select distinct 'HEMO' as Registry, primprocid, OTHER_DEVICE
               from registry_reporting.dfl_gen_AVACCESS_pso_v
               where nvl(OTHER_DEVICE,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_DEVICE as 'OTHER_DEVICE'))
union
select * from (select distinct 'HEMO' as Registry, primprocid, TYPE_FS_OTHER
               from registry_reporting.dfl_gen_AVACCESS_FBDS_C3_pso_v
               where nvl(TYPE_FS_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (TYPE_FS_OTHER as 'TYPE_FS_OTHER'))
union
select * from (select distinct 'HEMO' as Registry, primprocid, TYPE_STENT_AS_OTHER
               from registry_reporting.dfl_gen_AVACCESS_FBDS_C4_pso_v
               where nvl(TYPE_STENT_AS_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (TYPE_STENT_AS_OTHER as 'TYPE_STENT_AS_OTHER'))
union
select * from (select distinct 'HEMO' as Registry, primprocid, TYPE_STENT_CV_OTHER
               from registry_reporting.dfl_gen_AVACCESS_FBDS_C5_pso_v
               where nvl(TYPE_STENT_CV_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (TYPE_STENT_CV_OTHER as 'TYPE_STENT_CV_OTHER'))
union
select * from (select distinct 'HEMO' as Registry, primprocid, TYPE_STENT_OS_OTHER
               from registry_reporting.dfl_gen_AVACCESS_FBDS_C6_pso_v
               where nvl(TYPE_STENT_OS_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (TYPE_STENT_OS_OTHER as 'TYPE_STENT_OS_OTHER'))
union
select * from (select distinct 'HEMO' as Registry, primprocid, TYPE_STENT_IS_OTHER
               from registry_reporting.dfl_gen_AVACCESS_FBDS_C7_pso_v
               where nvl(TYPE_STENT_IS_OTHER,'N/A') != 'N/A')
unpivot (data for fields in (TYPE_STENT_IS_OTHER as 'TYPE_STENT_IS_OTHER'))
union
select * from (select distinct 'HEMO' as Registry, primprocid, OTHER_MATERIAL
               from registry_reporting.dfl_gen_AVACCESS_pso_v
               where nvl(OTHER_MATERIAL,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_MATERIAL as 'OTHER_MATERIAL'))
union
select * from (select distinct 'HEMO' as Registry, primprocid, OTHER_DEVICE
               from registry_reporting.dfl_gen_AVACCESS_pso_v
               where nvl(OTHER_DEVICE,'N/A') != 'N/A')
unpivot (data for fields in (OTHER_DEVICE as 'OTHER_DEVICE'))
"))

all_other_device_report[is.na(all_other_device_report)] <- ""

wb <- loadWorkbook("_All Other Devices Report TEMPLATE blank.xlsx", create=TRUE)
setStyleAction(wb,XLC$"STYLE_ACTION.NONE")
writeWorksheet(wb,all_other_device_report,"raw data",startRow=1,startCol=1,header=TRUE)
xlsx_name <- paste0("_All Other Devices Report ",date_formated,".xlsx")
saveWorkbook(wb,xlsx_name)

# write.csv(file = "all_other_device_report.csv",all_other_device_report,row.names = FALSE)

###
# Sales Mega Dictionary Query
#--delete the list tab data completely, then run this and export as csv. the commas in help cause problems with cut/paste. ???

sales_mega_dictionary <- fetch(dbSendQuery(con, "select In_BDS, Society, procshortname PROC,
decode (fwpcode, '1-',  'Proc', '1-1',  'LTF only', '1-30',  '30-Day only', '12-',  'Proc', '12-1',  'Early (0 to 6 months)', '12-2',  'Late (12 months)', '12-3,2,1',  'All Follow-Up Forms', '12-30',  '30-Day only', '15-',  'Proc', '15-1',  'LTF only',
        '15-30',  '30-Day only', '16-',  'Proc', '16-1',  'LTF only', '17-',  'Proc', '17-1',  '14-day Follow-up', '17-2',  '30-Day Follow-up', '17-3',  '90-day Follow-up', '17-4',  '1-year Follow-up', '17-5,4,3,2,1',  'All Follow-Up Forms',
        '18-',  'Proc', '18-1,2',  'LTF and Dissection Project 30D FU', '18-2',  'Dissection Project 30-Day Follow-up', '18-30',  '30-Day only', '19-',  'Proc', '19-1,2',  'LTF and Lombard Project 30-Day FU', '19-2',  'Lombard Project 30-Day FU', '19-30',  '30-Day only', '2-',  'Proc',
        '2-1',  '30-Day only', '2-1,30',  '30-Day only', '2-2',  'LTF only', '20-',  'Proc', '20-1',  ' Late (> 3 months)', '20-1,2',  'All Follow-Up Forms', '20-2',  'Early (0 to 3 months)', '21-',  'Proc', '21-1',  'Follow-Up',
        '22-',  'Proc', '22-1',  'Follow-Up', '23-',  'Proc', '23-1',  'LTF only', '23-30',  '30-Day only', '24-',  'Proc', '24-1',  'LTF only', '24-30',  '30-Day only', '25-',  'Proc',
        '25-1',  '3-Month Follow-up', '25-3',  'BOS Study 12-Month Follow-up', '25-3,2',  'BOS Study 6- and 12-Month Follow-up', '26-',  'Proc', '27-',  'Proc', '27-1',  'LTF only', '27-30',  '30-Day only', '28-',  'Proc', '28-1',  'LTF only',
        '4-',  'Proc', '4-1',  'LTF only', '4-30',  '30-Day only', '9-',  'Proc', '9-1',  'LTF only', '9-30',  '30-Day only', 'N/A') Form,
Pathways_Field_Name, BDS_Field_Name, field_name Pathways_Description,
Pathways_Help_Text, max(Supplementary_Help_BDS) Supplementary_Help_BDS, select_options, Dependencies, Retired_DT, Min(field_seq) SEQ, Pathways_Start_Date
from (
  select distinct decode (m.bdssetid, null, 'No', 'Yes') In_BDS,
  decode(r.societyid, '1','SVS','2', 'SNIS', '3','AVF','4','AOFAS','Other') Society, r.procshortname, p.field_seq,
  decode (p.dstype, 'F', 'LTF', 'P', 'Proc') Form, p.tab_name, p.field_code Pathways_Field_Name,
  case when m.header_name is null then p.field_code else m.header_name end as BDS_Field_Name, p.FIELD_NAME,
  p.help_text Pathways_Help_Text, m.supplementary_help_text Supplementary_Help_BDS, p.select_options,
  p.validation_translation Dependencies , p.RETIRED Retired_DT, p.PW_START_DT Pathways_Start_Date,
  p.procedureid || '-'||p.fwp_timepoints fwpcode
  from REGISTRY_REPORTING.dfl_proc_fields_comb_v p
  join registry_reporting.reg_procedure r on p.procedureid = r.procedureid
  left join rr_bds.bds_dfl_field_comb_mv m on p.procedureid = m.procedureid AND p.field_code = m.field_code
  where p.FIELD_NAME not like '%NA'
  and p.FIELD_NAME is not null
  and r.procshortname not in ('CAS', 'COST', 'DRAIN', 'DTR', 'ENDO_AAA', 'PQRI', 'PVI', 'TEVAR_OLD')
  order by decode(r.societyid, '1','SVS','2', 'SNIS', '3','AVF','4','AOFAS','Other'), r.procshortname, p.field_seq)
group by In_BDS, Society, procshortname, Form, Pathways_Field_Name, BDS_Field_Name, FIELD_NAME,
Pathways_Help_Text, select_options, Dependencies, Retired_DT, fwpcode, Pathways_Start_Date
order by Society, procshortname, min(field_seq)"))

sales_mega_dictionary$RETIRED_DT <- format(sales_mega_dictionary$RETIRED_DT,format="%d-%b-%y")
sales_mega_dictionary$PATHWAYS_START_DATE <- format(sales_mega_dictionary$PATHWAYS_START_DATE,format="%d-%b-%y")

sales_mega_dictionary[is.na(sales_mega_dictionary)] <- ""

wb <- loadWorkbook("_Sales Mega Dictionary TEMPLATE blank.xlsx", create=TRUE)
setStyleAction(wb,XLC$"STYLE_ACTION.NONE")
writeWorksheet(wb,sales_mega_dictionary,"List View",startRow=1,startCol=1,header=TRUE)
xlsx_name <- paste0("_Sales Mega Dictionary ",date_formated,".xlsx")
saveWorkbook(wb,xlsx_name)

# write.csv(file = "sales_mega_dictionary.csv",sales_mega_dictionary,row.names = FALSE)
###
# Centers, registries and subscriptions report

host <- "oci-mmmatrix-prod.local.medstreaming.net"
sid <- "MMMATRIX"
pwd <- pass <- getPass::getPass("Enter database password:")

port <- 1521
connect.string <- paste("(DESCRIPTION=", "(ADDRESS=(PROTOCOL=tcp)(HOST=",
                        host, ")(PORT=", port, "))", "(CONNECT_DATA=(SID=",
                        sid, ")))", sep = "")
con <- dbConnect(drv, username = "",
                 password = pwd, dbname = connect.string)

#--Raw Data
crs_raw_data <- fetch(dbSendQuery(con, "select distinct c.centerid, c.medcentername,
p.PROCSHORTNAME, c.ADDR1, c.CITY, c.STATE, c.ZIPCODE,
decode(p.SOCIETYID, '1', 'SVS', '2', 'SNIS', 'Other') Society
from vsgnne.reg_center c
join vsgnne.reg_regcenter rc on (c.centerid = rc.centerid)
join vsgnne.reg_regcenterproc rcp on (rc.regcenterid = rcp.regcenterid)
join vsgnne.reg_procedure p on (rcp.procedureid = p.procedureid)
join vsgnne.vsg_primproc vp on (p.procedureid = vp.procedureid and rc.regcenterid = vp.regcenterid)
where c.centerid <> 19
and p.procedurecode not in (10,3,11)
order by c.centerid, p.PROCSHORTNAME asc"))

crs_raw_data[is.na(crs_raw_data)] <- ""

# write.csv(file = "crs_raw_data.csv",crs_raw_data,row.names = FALSE)

#--Detail
crs_detail <- fetch(dbSendQuery(con, "
select * from
(select distinct c.medcentername, c.city, c.state, p.procshortname proc
  from vsgnne.reg_center c
  join vsgnne.reg_regcenter rc on (c.centerid = rc.centerid)
  join vsgnne.reg_regcenterproc rcp on (rc.regcenterid = rcp.regcenterid)
  join vsgnne.reg_procedure p on (rcp.procedureid = p.procedureid)
  left outer join vsgnne.reg_user u on c.LEAD_PHYS_ID = u.userid
  left join vsgnne.vsg_primproc vp on (p.procedureid = vp.procedureid and rc.regcenterid = vp.regcenterid)
  where C.CENTERId <> 19
  and c.CENTER_STATUS = ('2')--active only
)
pivot
(
  max(proc) for proc in ('AIS', 'AMP', 'AVACCESS', 'AVM', 'CAS_NEW', 'CBA', 'CEA', 'EVAR', 'INFRA', 'IVC', 'OFAR',
                         'OPEN_AAA', 'PVI_NEW', 'SUPRA', 'TEVAR', 'VMC', 'VSR', 'VUR', 'VV'))
order by medcentername asc"))

crs_detail[is.na(crs_detail)] <- ""

# write.csv(file = "crs_detail.csv",crs_detail,row.names = FALSE)

wb <- loadWorkbook("Centers and Subscriptions for Sales TEMPLATE blank.xlsx", create=TRUE)
setStyleAction(wb,XLC$"STYLE_ACTION.NONE")
writeWorksheet(wb,crs_raw_data,"raw data",startRow=1,startCol=1,header=TRUE)
writeWorksheet(wb,crs_detail,"Detail",startRow=1,startCol=1,header=TRUE)
xlsx_name <- paste0("Centers and Subscriptions for Sales ",date_formated,".xlsx")
saveWorkbook(wb,xlsx_name)
